##### Test t10.pl  --  Clipping  ###########################

BEGIN {
    $PDF_LIB = $ENV{"PDF_LIB"};
    unshift (@INC, $PDF_LIB);
}

use Pdf::File;
use Pdf::Font;
use Pdf::Graphic;

my $pdf = Pdf::File->new();
$pdf->pdfOpen ('./t10.pdf');

$pdf->newPage ();            ##### init. page

$x = 4.25 * 72;
$y = 9 * 72;

$g = $pdf->beginGraphic ();

$g->beginText ('Helvetica', 18);
$g->textCenter ($x, $y, 't10.pl:  Clipping');
$g->endText ();

$g->ctm (1, 0, 0, 1, $x, 6*72); #### shift to center of page

$d = 100;
$g->setColors ('s', 'red');
$g->setLinewidth (8);

$g->moveto (0, $d);            ##### start clipping path
$g->lineto (-$d, 0);
$g->lineto (0, -$d);
$g->lineto ($d, 0);
$g->closepath ();

$g->clip ();

$g->stroke ();

$g->setLinewidth (6);
$g->setColors ('s', 'blue');
$x = -$d;
$sl = $d/5;
$dy = $d/5;

for ($y = -$d-$sl; $y<$d+$sl; $y +=$dy) {
	$g->moveto ($x, $y);
	$g->lineto ($x+2*$d, $y+$sl);
	$g->stroke ();
};

$g->endGraphic ();

$pdf->pdfClose ();

#####################  E N D  ##############################
