##### Test t12.pl  --  Text Blocks and Text Parameters  ####

BEGIN {
    $PDF_LIB = $ENV{"PDF_LIB"};
    unshift (@INC, $PDF_LIB);
}

use Pdf::File;
use Pdf::Font;
use Pdf::Graphic;

my $pdf = Pdf::File->new();
$pdf->pdfOpen ('./t12.pdf');

$pdf->newPage ();            ##### init. page

$x = 4.25 * 72;
$y = 9 * 72;

$g = $pdf->beginGraphic ();

$g->beginText ('Helvetica', 18);
$g->textCenter ($x, $y, 't12.pl:  Text Block and Parameters');
$g->endText ();

$y = 8*72;

@tb = ('We use this same block for testing',
       'the different text parameters:',
       'character spacing, word spacing,',
       'leading,.....');

$dy = 90;
$xleft = 72;
$xcenter = 4.25 * 72;
$xright = 7.25 * 72;
$fn = 'Helvetica';
$fs = 12;
$l = 14;

$g->textBlockLeft ($xleft, $y, $fn, $fs, $l, @tb);

$y -= $dy;
$g->setCharSpace (8);

$g->textBlockRight ($xright, $y, $fn, $fs, $l, @tb);

$y -= $dy;
$g->setCharSpace (0);
$g->setTextWordSpace (8);

$g->textBlockCenter ($xcenter, $y, $fn, $fs, $l, @tb);

$y -= $dy;
$g->setTextWordSpace (0);
$l = 20;

$g->textBlockLeft ($xleft, $y, $fn, $fs, $l, @tb);

$y -= $dy;
$l = 14;
$g->setTextHorizScale (70);

$g->textBlockLeft ($xleft, $y, $fn, $fs, $l, @tb);

$y -= $dy;
$g->setTextHorizScale (130);

$g->textBlockLeft ($xleft, $y, $fn, $fs, $l, @tb);

$g->setTextHorizScale (100);

$g->endGraphic ();

$pdf->newPage ();

$g = $pdf->beginGraphic ();

@offset = (1.0, 0.75, 0.5, 0.25, 0);

$g->beginText ('Helvetica', 18);
$g->textCenter (4.25*72, 9*72, "t12.pl:  textBlockOffset ({@offset}, ....)");
$g->endText ();

$y = 8 * 72;
	
foreach $offs (@offset) { 
	
      $g->textBlockOffset ($offs, $xcenter, $y, $fn, $fs, $l, @tb);
      $y -= $dy;
}
	
$g->endGraphic ();

$pdf->pdfClose ();

#####################  E N D  ##############################
