##### Test t13.pl  --  Set Color Spaces  ###################

BEGIN {
    $PDF_LIB = $ENV{"PDF_LIB"};
    unshift (@INC, $PDF_LIB);
}

use Pdf::File;
use Pdf::Font;
use Pdf::Graphic;

my $pdf = Pdf::File->new();
$pdf->pdfOpen ('./t13.pdf');

$pdf->newPage ();            ##### init. page

$x = 4.25 * 72;
$y = 9 * 72;

$g = $pdf->beginGraphic ();

$g->beginText ('Helvetica', 18);
$g->textCenter ($x, $y, 't13.pl:  Set Color Spaces');
$g->endText ();

$tx = 50;
$d = 30;

$g->ctm (1, 0, 0, 1, 3*72, 8*72); #### shift to center page

$g->setColors ('f', 'DeviceRGB', 0.2, 0.3, 0.7);

$g->moveto (0, $d);            ##### start path
$g->lineto (-$d, 0);
$g->lineto (0, -$d);
$g->lineto ($d, 0);
$g->closepath ();
$g->fill ();

$g->beginText (15);
$g->textLeft ($tx, 0, 'DeviceRGB  0.2  0.3  0.7');
$g->endText ();

$g->ctm (1, 0, 0, 1, 0, -72);  ##### shift down one inch

$g->setColors ('f', 0.7, 0.2, 0.2);

$g->moveto (0, $d);            ##### start path
$g->lineto (-$d, 0);
$g->lineto (0, -$d);
$g->lineto ($d, 0);
$g->closepath ();
$g->fill ();

$g->beginText ();
$g->textLeft ($tx, 0, 'DeviceRGB  0.7  0.6  0.2');
$g->endText ();

$g->ctm (1, 0, 0, 1, 0, -72);  ##### shift down one inch

$g->setColors ('f', 'DeviceCMYK', 0.8, 0.3, 0.2, 0.1);

$g->moveto (0, $d);            ##### start path
$g->lineto (-$d, 0);

$g->lineto (0, -$d);
$g->lineto ($d, 0);
$g->closepath ();
$g->fill ();

$g->beginText ();
$g->textLeft ($tx, 0, 'DeviceCMYK  0.8  0.3  0.2  0.1');
$g->endText ();

$g->ctm (1, 0, 0, 1, 0, -72);  ##### shift down one inch

$g->setColors ('f', 0.2, 0.3, 0.9, 0.1);

$g->moveto (0, $d);            ##### start path
$g->lineto (-$d, 0);

$g->lineto (0, -$d);
$g->lineto ($d, 0);
$g->closepath ();
$g->fill ();

$g->beginText ();
$g->textLeft ($tx, 0, 'DeviceCMYK  0.2  0.3  0.9  0.1');
$g->endText ();

$g->ctm (1, 0, 0, 1, 0, -72);  ##### shift down one inch

$g->setColors ('f', 'DeviceGray',  0.8);

$g->moveto (0, $d);            ##### start path
$g->lineto (-$d, 0);
$g->lineto (0, -$d);
$g->lineto ($d, 0);
$g->closepath ();
$g->fill ();

$g->beginText ();
$g->textLeft ($tx, 0, 'DeviceGRAY  0.8');
$g->endText ();

$g->ctm (1, 0, 0, 1, 0, -72);  ##### shift down one inch

$g->setColors ('f', 0.3);

$g->moveto (0, $d);            ##### start path
$g->lineto (-$d, 0);
$g->lineto (0, -$d);
$g->lineto ($d, 0);
$g->closepath ();
$g->fill ();

$g->beginText ();
$g->textLeft ($tx, 0, 'DeviceGRAY  0.3');
$g->endText ();

$g->endGraphic ();

$pdf->pdfClose ();

#####################  E N D  ##############################
