##### Test t2.pl  --  Two Pages  ###########################

BEGIN {
     $PDF_LIB = $ENV{"PDF_LIB"};
     unshift (@INC, $PDF_LIB);
}

use Pdf::File;
use Pdf::Font;
use Pdf::Graphic;

my $pdf = Pdf::File->new();
$pdf->pdfOpen ('./t2.pdf');

$pdf->newPage ();            ##### start of first page

$g = $pdf->beginGraphic ();

$g->beginText ('Helvetica', 18);
$g->textLeft (72, 650, 
    "t2.pl:  On this page text and graphics are drawn using the");
$g->textRight (540, 610, 
    "default environment (except for font and fontsize)!");
$g->endText ();

&strokeLine (120, 200, 370, 450);
&strokeLine (120, 250, 370, 500);

$g->rectangle (400, 300, 100, 100);
$g->fill ();

$g->endGraphic ();

$pdf->newPage ();            ##### start of second page

$g = $pdf->beginGraphic ();

$g->setColors ('f', 'red');

$g->beginText ('Helvetica-Bold', 24);
$g->textLeft (120, 600, "t2.pl: Second Page!  The Fun starts!");
$g->endText ();

$g->setLinewidth (5);
$g->setColors ('s', 'blue');
$g->setColors ('f', 'yellow');
$g->rectangle (250, 400, 100, 100);
$g->fillStroke ();

$g->setColors ('s', 'green');
&strokeLine (245, 200, 295, 275);

$g->setColors ('s', 'darkblue');
&strokeLine (305, 275, 355, 200);

$g->setColors ('s', 'red');
&strokeLine (247, 192, 353, 192);

$g->endGraphic ();

$pdf->pdfClose ();


sub strokeLine {
       $g->moveto ($_[0], $_[1]);
       $g->lineto ($_[2], $_[3]);
       $g->stroke ();
}

#####################  E N D  ##############################
