##### t5.pl  --  Line Samples on smaller page size  ########

BEGIN {
     $PDF_LIB = $ENV{"PDF_LIB"};
     unshift (@INC, $PDF_LIB);
}

use Pdf::File;
use Pdf::Font;
use Pdf::Graphic;

my $pdf = Pdf::File->new();
$pdf->pdfOpen ('./t5.pdf');

                           ##### change of default page size
$w = 6 * 72;
$h = 8 * 72;
$pdf->setPageSize ($w, $h);

$pdf->newPage ();          ##### start of first page: varying lines

$g = $pdf->beginGraphic ();

$x = 120;
$y = 470;

$g->beginText ('Helvetica-Bold', 18);
$g->textLeft ($x, $y, 't5.pl:  Line Width examples');
$g->endText ();

$x += 35;
$y -= 55;
$ll = 100;
$ld = 50;
$td = 115;
@lwa = ('1', '3', '5', '10', '15', '20', '25');

foreach $lw (@lwa) {
	$g->setLinewidth (0+$lw);
	strokeLine ($x, $y, $x+$ll, $y);

	$g->beginText (12);
	$g->textLeft ($x+$td, $y-5, $lw);
	$g->endText ();

	$y -= $ld;
}

$g->endGraphic ();

$pdf->newPage ();          ##### start new page: dash patterns

$g = $pdf->beginGraphic ();

$y = 470;
$x = 120;

$g->beginText ('Helvetica-Bold', 18);
$g->textLeft ($x, $y, 't5.pl:  Dashed Line Examples');
$g->endText ();

$x -= 5;
$y -= 55;
$ll = 200;
$lw = 4;
$ld = 50;
$td = 215;

$g->setLinewidth ($lw);

@da = ( [4], [4], [4, 2], [3, 5], [2, 3], [6, 3, 2, 3]);
@pa = (0, 4, 0, 3, 0, 9);

foreach $i (0..5) {
	@a = @{$da[$i]};
	$p = $pa[$i];
	$g->setDashPattern (\@a, $p);
	strokeLine ($x, $y, $x+$ll, $y);

	$g->beginText (12);
	$g->textLeft ($x+$td, $y-$lw/2, $p);
	$g->endText ();

	$y -= $ld;
};

$g->endGraphic ();

$pdf->newPage ();          ##### start new page: line cap styles

$g = $pdf->beginGraphic ();

$y = 470;
$x = 120;

$g->beginText ('Helvetica-Bold', 18);
$g->textLeft ($x, $y-5, 't5.pl:  Line Cap Examples');
$g->endText ();

$x += 35;
$y -= 55;
$ll = 100;
$ld = 75;
$td = 115;

$g->setLinewidth (15);

foreach $cap (0, 1, 2) {
	$g->setLineCapStyle ($cap);
	strokeLine ($x, $y, $x+$ll, $y);

	$g->beginText (12);
	$g->textLeft ($x+$td, $y-5, $cap);
	$g->endText ();

	$y -= $ld;
};

$g->endGraphic ();

$pdf->newPage ();          ##### start new page: miter styles

$g = $pdf->beginGraphic ();

$x = $w/2;
$y = $h - 60;

$g->beginText ('Helvetica-Bold', 18);
$g->textCenter ($x, $y, 't5.pl:  Miter Style Examples');
$g->endText ();

$y -= 150;
$w = 50;
$h = 100;
$x -= $w;
$ld = 150;
$td = 150;

$g->setLinewidth (15);

foreach $m (0, 1, 2) {

	$g->setJoinStyle ($m);
	$g->moveto ($x, $y);
	$g->lineto ($x+$w, $y+$h);
	$g->lineto ($x+2*$w, $y);
	$g->stroke ();

	$g->beginText (12);
	$g->textLeft ($x+$td, $y+$h/2, $m);
	$g->endText ();

	$y -= $ld;
};

$g->endGraphic ();

$pdf->pdfClose ();


sub  strokeLine  {
        $g->moveto ($_[0], $_[1]);
        $g->lineto ($_[2], $_[3]);
	$g->stroke ();
}
#####################  E N D  ##############################
