##### t6.pl  --  Bezier Curves  ############################

BEGIN {
     $PDF_LIB = $ENV{"PDF_LIB"};
     unshift (@INC, $PDF_LIB);
}

use Pdf::File;
use Pdf::Font;
use Pdf::Graphic;

my $pdf = Pdf::File->new();
$pdf->pdfOpen ('./t6.pdf');

$pdf->newPage ();

$g = $pdf->beginGraphic ();

$xc = 4.25 * 72;
$yc = 9 * 72;
$g->beginText ('Helvetica-Bold', 18);
$g->textCenter ($xc, $yc, 't6.pl:  Bezier Curve Examples');
$g->endText ();

$D = 250;                 ## width of curve sample
$dx = 50;                 ## init. x-diff of Curr.Pt. and P1
                          ## and of P2 and P3
$d = $D - 2*$dx;          ## init. x-diff. of P1 and P2
$dy = 100;                ## height of curve
$tdu = 12;                ## upper vertical text adjustment
$tdl = 16;                ## lower vertical text adjustment    

$x = $xc - $dx - $d/2;    ## x-coord. of current point
$y = $yc - 60 - $dy;      ## y-coord. of init. current point
$x1 = $x + $dx;           ## x-coord. of 1. control point  
$x2 = $x1 + $d;           ## x-coord. of 2. control point
$x3 = $x2 + $dx;          ## x-coord. of end point
$y1 = $y + $dy;           ## init. y-coord. of both ctrl pts

foreach $s (0, 25, 25) {

	$x1 -= $s;
	$x2 -= $s;

	$g->setLinewidth (3);
	$g->setColors ('s', 'black');

	$g->moveto ($x, $y);
	$g->curveto ($x1, $y1, $x2, $y1, $x3, $y);
	$g->stroke ();

	$g->setLinewidth (1);
	$g->setColors ('s', 'red');

	$g->moveto ($x, $y);
	$g->lineto ($x1, $y1);
	$g->moveto ($x3, $y);
	$g->lineto ($x2, $y1);
	$g->stroke;

	$g->beginText ('Helvetica-Bold', 12);
	$g->textCenter ($x, $y-$tdl, 'Curr. Pt.'); 
	$g->textCenter ($x1, $y1+$tdu, 'P1');
	$g->textCenter ($x2, $y1+$tdu, 'P2');
	$g->textCenter ($x3, $y-$tdl, 'P3');
	$g->endText ();

	$y  -= $d + 40;
	$y1 -= $d + 40;
	$y2 -= $d + 40;
	$y3 -= $d + 40;

};

$g->endGraphic ();

$pdf->pdfClose ();

#####################  E N D  ##############################
