##### Test t7.pl  --  Scaled and Boxed Text String  ########

BEGIN {
     $PDF_LIB = $ENV{"PDF_LIB"};
     unshift (@INC, $PDF_LIB);
}

use Pdf::File;
use Pdf::Font;
use Pdf::Graphic;

my $pdf = Pdf::File->new();
$pdf->pdfOpen ('./t7.pdf');

$pdf->newPage ();            ##### init. page

$x = 4.25 * 72;
$y = 9 * 72;

$g = $pdf->beginGraphic ();

$g->beginText ('Helvetica', 24);
$g->textCenter ($x, $y, 't7.pl:  Scaled and Boxed Text');
$g->endText ();

$p = 18;
$d = 80;
$y -= 100;

$s = 'Text horizontally normal';
$g->beginText ($p);
$g->textCenter ($x, $y, $s);
$g->endText ();

$y -= $d;

$s = 'Text horizontally compressed';
	
$g->beginText ();
$g->setTextHorizScale (60);
$g->textCenter ($x, $y, $s);
$g->endText ();
$w = $g->textWidth ($s);
$llx = $x - $w/2;
$lly = $y - 0.2*$p;
$urx = $llx + $w;
$ury = $lly + $p;

$g->rectangle ($llx, $lly, $urx-$llx, $ury-$lly);
$g->stroke ();

$g->setColors ('f', 'yellow');

$d = 100;
$lly -= $d;
$ury -= $d;

$s = 'Text horizontally expanded';
$g->setTextHorizScale (130);
$w = $g->textWidth ($s);
$llx = $x - $w/2;
$urx = $llx + $w;

$g->rectangle ($llx, $lly, $urx-$llx, $ury-$lly);
$g->fill ();

$g->setColors ('f', 'black');

$y -= $d;

$g->beginText ();
$g->textCenter ($x, $y, $s);
$g->endText ();

$g->endGraphic ();

$pdf->pdfClose ();

#####################  E N D  ##############################
