##### Test t8.pl  --  Circular Arcs and Circles  ###########

BEGIN {
    $PDF_LIB = $ENV{"PDF_LIB"};
    unshift (@INC, $PDF_LIB);
}

use Pdf::File;
use Pdf::Font;
use Pdf::Graphic;

my $pdf = Pdf::File->new();
$pdf->pdfOpen ('./t8.pdf');

$pdf->newPage ();            ##### init. page

$x = 4.25 * 72;
$y = 9 * 72;

$g = $pdf->beginGraphic ();

$g->beginText ('Helvetica', 18);
$g->textCenter ($x, $y,
                't8.pl:  Circular Arcs (one Bezier segment each)');
$g->endText ();

$ax = 4.25 * 72;
$ay = $y - 120;

foreach $w (25, 35, 45, 90) {

	@ar = &arc (100, $w);

	$g->setColors ('s', 'black');
	$g->setLinewidth (2);
	$g->moveto ($ax+$ar[0], $ay+$ar[1]);
	$g->curveto ($ax+$ar[2], $ay+$ar[3], $ax+$ar[4],
                     $ay+$ar[5], $ax+$ar[6], $ay+$ar[7]);
	$g->stroke ();

	$g->setColors ('s', 'red');
	$g->setLinewidth (0.5);
	$g->moveto ($ax+$ar[0], $ay+$ar[1]);
	$g->lineto ($ax, $ay);
	$g->lineto ($ax+$ar[6], $ay+$ar[7]);
	$g->stroke ();

	$ay -= 130;
};

$g->endGraphic ();

$pdf->newPage ();            ##### init. page

$ax = 4.25 * 72;
$ay = $y - 72;

$g = $pdf->beginGraphic ();

$g->beginText ('Helvetica', 18);
$g->textCenter ($x, $y,
                't8.pl:  Circles (from two Bezier half circles)');
$g->endText ();

$d = 20;

foreach $r (25, 50, 100) {

	$ay -= $r;

	@ci = &arc ($r, 90);     ##### half circle by Bezier

	$c0 = $ax+$ci[0];        ##### adjust coordinates
	$c1 = $ay+$ci[1];
	$c2 = $ax+$ci[2];
	$c3 = $ay+$ci[3];
	$c4 = $ax+$ci[4];
	$c5 = $ay+$ci[5];
	$c6 = $ax+$ci[6];
	$c7 = $ay+$ci[7];

	$g->setLinewidth (2);
	$g->setColors ('s', 'black');

                                 ##### move to and draw curve
   	$g->moveto ($c0, $c1);
	$g->curveto ($c2, $c3, $c4, $c5, $c6, $c7);
	$g->stroke ();

	$c0 = $ax-$ci[0];        ##### adjust coordinates
	$c1 = $ay-$ci[1];
	$c2 = $ax-$ci[2];
	$c3 = $ay-$ci[3];
	$c4 = $ax-$ci[4];
	$c5 = $ay-$ci[5];
	$c6 = $ax-$ci[6];
	$c7 = $ay-$ci[7];

                                 ##### move to and draw curve
	$g->moveto ($c0, $c1);
	$g->curveto ($c2, $c3, $c4, $c5, $c6, $c7);
	$g->stroke ();

	$y1 = $c1;               ##### set for red line
	$x1 = $ax - $r - $d;
	$x2 = $x1 + 2*($r+$d);

	$g->setLinewidth (0.5);
	$g->setColors ('s', 'red');

	$g->moveto ($x1, $y1);   ##### draw red line
	$g->lineto ($x2, $y1);
	$g->stroke ();

	$ay -= $r + 50;          ##### adjust vert. pos.
};

$g->endGraphic ();

$pdf->pdfClose ();

sub arc {
	$r = $_[0];
	$a = (3.141593 / 180) * $_[1];

	$l = ( $r * (4/3) * (1 - cos ($a)) ) / sin ($a);
	$x3 = $r * cos (2*$a);
	$y3 = $r * sin (2*$a);
	$x2 = &chop ($x3 + $l * sin (2*$a));
	$y2 = &chop ($y3 - $l * cos (2*$a));
	$x3 = &chop ($x3);
	$y3 = &chop ($y3);
	$x1 = &chop ($r);
	$y1 = &chop ($l);
	$x0 = $r;
	$y0 = 0;
	@ret = ($x0, $y0, $x1, $y1, $x2, $y2, $x3, $y3);
	return @ret;
}

sub  chop {
	return  ( int ($_[0] * 1000) ) / 1000;
}

#####################  E N D  ##############################
