##### Test t9.pl  --  The Transformation Matrix  ###########

BEGIN {
    $PDF_LIB = $ENV{"PDF_LIB"};
    unshift (@INC, $PDF_LIB);
}

use Pdf::File;
use Pdf::Font;
use Pdf::Graphic;

my $pdf = Pdf::File->new();
$pdf->pdfOpen ('./t9.pdf');

$pdf->newPage ();            ##### init. page

$x = 4.25 * 72;
$y = 9 * 72;

$g = $pdf->beginGraphic ();

$g->beginText ('Helvetica', 18);
$g->textCenter ($x, $y, 't9.pl:  The Transformation Matrix');
$g->endText ();

$x = 72;
$y -= 100;

$g->setColors ('f', 'red');
$g->beginText ('Times-Roman', 24);
$g->textLeft ($x, $y, 'Sample Text BEFORE transformation!');
$g->endText ();

$g->gsave ();

$g->ctm (1, 0, 0, 1, 180, 0);
$g->ctm (0.7, 0, 0, 1, 0, 0);

$y -= 100;

$g->setColors ('f', 'blue');
$g->beginText ('Times-Roman', 24);
$g->textLeft ($x, $y,
              'Sample Text AFTER translation and scaling!');
$g->endText ();

$g->grestore ();

$g->ctm (0.7, 0, 0, 1, 0, 0);
$g->ctm (1, 0, 0, 1, 180, 0);

$y -= 100;

$g->beginText ();
$g->textLeft ($x, $y,
              'Sample Text AFTER scaling and translation!');
$g->endText ();

$g->endGraphic ();

$pdf->pdfClose ();

#####################  E N D  ##############################
